//Computer Graphics 2013 nccu HW0 
//Matrix operations

//Important: Opengl Matrix is column major

#include <iostream>
using namespace std;

#include "smatrix.h"

const double MatrixI[16] = {
	1, 0, 0, 0,
	0, 1, 0, 0,
	0, 0, 1, 0,
	0, 0, 0, 1
};

double MatrixA[16] = {
	1, 2, 3, 4,
	5, 6, 7, 8,
	9, 10, 11, 12,
	13, 14, 15, 16
};


double MatrixB[16] = {
	1, 3, 2, 1,
	0, 1, 5, 4,
	0, 0, 1, 6,
	0, 0, 0, 1
};

double MatrixAxA[16] = {
	90, 100, 110, 120,
	202, 228, 254, 280,
	314, 356, 398, 440,
	426, 484, 542, 600
	
};

double MatrixAxB[16] = {
	47, 54, 61, 68,
	102, 112, 122, 132,
	87, 94, 101, 108,
	13, 14, 15, 16
};

double Vector1[4] = {1, 2, 3, 4 };



void DoATest(const char testname[], bool iswork)
{
	if(iswork)
		cout<<testname<<" pass.\n";
	else
		cout<<testname<<" fail.\n";
}

int main(int argc, char **argv)
{

	double A[16], B[16], C[16];

	MatrixPrint(MatrixA);
	MatrixPrint(MatrixAxA);

	//test
	//I == I
	MatrixIdentity(A);
	DoATest("I == I", MatrixIsEqual(MatrixI, A));

	//I == I*I
	MatrixAssign(A, B);
	MatrixMul(A, B, C);
	DoATest("I == I*I", MatrixIsEqual(MatrixI, C));

	//A == (A*I)
	MatrixMul(MatrixA, A, C);
	DoATest("A == (A*I)", MatrixIsEqual(MatrixA, C));

	//A == (I*A)
	MatrixMul(A, MatrixA, C);
	DoATest("A == (I*A)", MatrixIsEqual(MatrixA, C));

	//"A*A" == (A*A)
	MatrixMul(MatrixA, MatrixA, C);
	DoATest("A*A == (A*A)", MatrixIsEqual(MatrixAxA, C));

	//"A*B" == (A*B)
	MatrixMul(MatrixA, MatrixB, C);
	DoATest("A*B == (A*B)", MatrixIsEqual(MatrixAxB, C));

	//v1 == (I*v1)
	double vtemp[4];
	MatrixMulVector(MatrixI, Vector1, vtemp);
	DoATest("v1 == (I*v1)", VectorIsEqual(Vector1, vtemp));


	return 0;
}


